=== debian/changelog ===
wcd (5.3.4-1build2) bionic; urgency=medium

  * Rebuild against new libunistring 0.9.9.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 04 Mar 2018 09:26:28 +0100

wcd (5.3.4-1build1) bionic; urgency=medium

  * Rebuild against new libunistring2.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 13 Feb 2018 16:31:07 +0100

wcd (5.3.4-1) unstable; urgency=medium

  * New upstream release.
  * debian/control
    - (Build-Depends): use debhelper 10.
  * debian/copyright
    - Update years.
  * debian/patches
    - (10): Update. Use version.mk from original sources for date.

 -- Jari Aalto <jari.aalto@cante.net>  Sun, 08 Jan 2017 13:19:45 +0200

wcd (5.3.3-1) unstable; urgency=medium

  * New upstream release.
  * debian/control
    - (Homepage): Update.
    - (Standards-Version): Update to 3.9.8.
    - (Vcs-*): Update to anonscm.debian.org.
  * debian/copyright
    - Update URLs.
  * debian/patches
    - (10): New. Make build reproducible (Closes: 796375).
      Patch thanks to Eduard Sanou <dhole@openmailbox.org>.
  * debian/source/options
    - New file.

 -- Jari Aalto <jari.aalto@cante.net>  Thu, 20 Oct 2016 17:47:37 +0300
