=== src/Makefile ===
#   Copyright information
#
#       Copyright (C) 2009-2018 Erwin Waterlander
#       Copyright (C) 2009 Jari Aalto
#
#   License
#
#       This program is free software; you can redistribute it and/or
#       modify it under the terms of the GNU General Public License as
#       published by the Free Software Foundation; either version 2 of the
#       License, or (at your option) any later version
#
#       This program is distributed in the hope that it will be useful, but
#       WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#       General Public License for more details at
#       Visit <http://www.gnu.org/copyleft/gpl.html>.
#
#   Description
#
#       This is a GNU Makefile that uses GNU compilers, linkers and cpp. The
#       platform specific issues are determined by the various OS teets that
#       rely on the uname(1) command and directory locations.
#
#   Developer notes
#
#       In order to clean generated POD files and manuals:
#
#           make maintainer-clean
#
#       Set additional flags for the build with variables CFLAGS_USER,
#       DEFS_USER and LDFLAGS_USER.

ifneq (,)
This makefile requires GNU Make.
endif

include version.mk

.PHONY: status uninstall install install-man install-doc install-pdf dist dist-zip dist-tgz
.PHONY: doc man txt html ps pdf mofiles tags merge


.PRECIOUS: %.1 %.pod

CC              ?= gcc
STATIC          =
STRIP           = strip

ENABLE_NLS = 1

PACKAGE         = wcd
EXT             = .exe
PROGRAM         = $(PACKAGE)$(EXT)
BIN             = $(PROGRAM)

PREFIX          = /usr
prefix          = $(PREFIX)
exec_prefix     = $(prefix)
bindir          = $(exec_prefix)/bin
datarootdir     = $(prefix)/share
datadir         = $(datarootdir)

docsubdir       = $(PACKAGE)-$(VERSION)
docdir          = $(datarootdir)/doc/$(docsubdir)
localedir       = $(datarootdir)/locale
sysconfdir      = /etc

# 1 = regular, 5 = conf, 6 = games, 8 = daemons
mandir          = $(datarootdir)/man
man1dir         = $(mandir)/man1


# On some systems (e.g. FreeBSD 4.10) GNU install is installed as `ginstall'.
INSTALL         = install
# On some systems (e.g. GNU Win32) GNU mkdir is installed as `gmkdir'.
MKDIR           = mkdir

INSTALL_PROGRAM = $(INSTALL) -m 755
INSTALL_DATA    = $(INSTALL) -m 644
INSTALL_SUID    = $(INSTALL) -m 4755

INSTALL_OBJS_BIN   = $(BIN)
HTMLEXT = htm

# English manual
MANFILES_EN  = man/man1/wcd.1
TXTFILES_EN  = man/man1/wcd.txt
HTMLFILES_EN  = man/man1/wcd.$(HTMLEXT)
PSFILES_EN  = man/man1/wcd.ps
PDFFILES_EN  = man/man1/wcd.pdf

# Documents for end users, not for developers:
INSTALL_OBJS_DOC   = \
  ../doc/faq.txt \
  ../doc/whatsnew.txt \
  ../doc/README.txt \
  ../doc/problems.txt \
  ../doc/todo.txt \
  ../doc/INSTALL.txt \
  ../doc/UNIX.txt \
  ../doc/copying.txt

ifdef ENABLE_NLS
POT             = po/$(PACKAGE).pot
POFILES         = $(wildcard po/*.po)
MOFILES         = $(patsubst %.po,%.mo,$(POFILES))
NLSSUFFIX       = -nls
endif

# International manuals
ifdef ENABLE_NLS
MANPOTFILE      = po-man/wcd-man.pot
MANPOFILES      = $(wildcard po-man/*.po)
MANPODFILES     = $(patsubst po-man/%.po,man/%/man1/wcd.pod,$(MANPOFILES))
endif
MANFILES        = $(patsubst %.pod,%.1,$(MANPODFILES))
TXTFILES        = $(patsubst %.pod,%.txt,$(MANPODFILES))
HTMLFILES       = $(patsubst %.pod,%.$(HTMLEXT),$(MANPODFILES))
PSFILES         = $(patsubst %.pod,%.ps,$(MANPODFILES))
PDFFILES        = $(patsubst %.pod,%.pdf,$(MANPODFILES))

CPP             = cpp
CFLAGS_VERSION  = -DVERSION=\"$(VERSION)\" -DVERSION_DATE=\"$(VERSION_DATE)\"
DEF_UNIX        = -DUNIX
EXTRA_DEFS      =

VERSIONSUFFIX   = -bin

# Large File Support (LFS)
LFS             = 1
# DEBUG=1 adds the -g option to CFLAGS, for adding debug symbols.
DEBUG = 0
# DEBUGMSG=1 adds -DDEBUG=1 to CFLAGS, for extra verbose messages.
DEBUGMSG = 0

wcd_os := $(shell uname)

# Enble Unicode
UCS = 1
ifdef WCD_UTF8
        # WCD_UTF8 was used in older versions.
        UCS=1
endif
ifdef UNINORM
        UCS = 1
endif


ZIPOBJ          = bin/$(BIN) \
                  share/man/man1/$(PACKAGE).1 \
                  share/doc/$(docsubdir)/*.* \
                  $(ZIPOBJ_EXTRA)

INSTALL_TARGETS = install-bin install-man install-doc

ifdef ENABLE_NLS
        INSTALL_TARGETS += install-mo
        ZIPOBJ += share/locale/*/LC_MESSAGES/$(PACKAGE).mo
        ZIPOBJ += share/man/*/man1/$(PACKAGE).1
        ZIPOBJ += share/doc/$(docsubdir)/*/*
endif

ifdef ENABLE_NLS
        NLSDEFS    = -DENABLE_NLS -DLOCALEDIR=\"$(localedir)\" -DPACKAGE=\"$(PACKAGE)\"
endif

# ......................................................... OS flags ...

OS =

ifndef OS
ifeq ($(findstring CYGWIN,$(wcd_os)),CYGWIN)
        OS = cygwin
endif
endif

ifndef OS
ifeq ($(findstring MSYS,$(wcd_os)),MSYS)
        OS = msys
# MSYS 1 does not support locales and no Unicode.
ifeq ($(shell ./chk_loc.sh en_US.utf8),no)
        MSYS_VERSION=1
else
        MSYS_VERSION=2
endif
endif
endif

ifndef OS
ifeq ($(findstring MINGW,$(wcd_os)),MINGW)
        OS = mingw
endif
endif

ifndef OS
ifneq ($(DJGPP),)
        OS = msdos
endif
endif

ifndef OS
ifneq (, $(wildcard /opt/csw))
        OS = sun
endif
endif

ifndef OS
        OS=$(shell echo $(wcd_os) | tr '[A-Z]' '[a-z]')
endif


ifeq (cygwin,$(OS))
ifdef ENABLE_NLS
        LIBS_EXTRA    = -lintl -liconv -lmpr
else
        LIBS_EXTRA    = -lmpr
endif
        UNINORM = 1  
        LDFLAGS_EXTRA = -Wl,--enable-auto-import
        INSTALL_TARGETS += install-profile
        docsubdir       = $(PACKAGE)
        MACHINE := $(subst -pc-cygwin,,$(shell gcc -dumpmachine))
        VERSIONSUFFIX   = -cygwin-$(MACHINE)
endif

ifeq (os/2,$(OS))
        prefix = c:/usr
        PROGRAM = wcdos2.exe
        DEF_UNIX =
        UCS =
        UNINORM =
        LDFLAGS_EXTRA = -Zhigh-mem -Zomf -Zargs-resp
        ZIPOBJ_EXTRA=bin/wcd.cmd
        VERSIONSUFFIX = -os2
        LIBS_EXTRA =
ifdef ENABLE_NLS
        LIBS_EXTRA += -lintl
endif
endif

ifeq (mingw,$(OS))
        CC = gcc
        DEF_UNIX =
        LIBS_EXTRA = -lkernel32 -luser32 -lmpr
ifdef ENABLE_NLS
        LIBS_EXTRA += -lintl -liconv
endif
endif

ifeq (msdos,$(OS))
        CC = gcc
        DEF_UNIX =
        UCS =
        UNINORM =
endif

ifeq (msys,$(OS))
        CC = gcc
        CFLAGS_OS = -DWCD_MSYS
        PROGRAM = wcdmsys.exe
        LIBS_EXTRA  = -lkernel32 -luser32 -lmpr
        MACHINE := $(subst -pc-msys,,$(shell gcc -dumpmachine))
ifeq ($(MSYS_VERSION),1)
        UCS =
        UNINORM =
        VERSIONSUFFIX = -msys1-$(MACHINE)-$(CURSES)
else
        UCS = 1
        UNINORM = 1
        VERSIONSUFFIX = -msys2-$(MACHINE)
endif
ifdef ENABLE_NLS
        LIBS_EXTRA += -lintl -liconv
endif
endif

ifeq (freebsd,$(OS))
        # Running under FreeBSD
ifdef ENABLE_NLS
        CFLAGS_OS     = -I/usr/local/include
        LDFLAGS_EXTRA = -L/usr/local/lib
        LIBS_EXTRA    = -lintl
endif
endif

ifeq (darwin, $(OS))
ifdef ENABLE_NLS
        CFLAGS_OS     = -I/usr/local/include
        LDFLAGS_EXTRA = -L/usr/local/lib
        LIBS_EXTRA    = -lintl
endif
endif


ifeq (sun,$(OS))
        # Running under SunOS/Solaris
        LIBS_EXTRA = -lintl
endif

ifeq (hp-ux,$(OS))
        # Running under HP-UX
        EXTRA_DEFS += -Dhpux -D_HPUX_SOURCE -D_XOPEN_SOURCE_EXTENDED

        # These flags were for native HP compiler
        # CFLAGS_OS = -O -Aa
endif

# .......................................................... unicode ...

ifdef UCS
        CFLAGS_UCS = -std=gnu99
        WDEFS      = -DWCD_UNICODE
endif
ifdef UNINORM
        CFLAGS_UCS = -std=gnu99
        WDEFS      = -DWCD_UNICODE -DWCD_UNINORM
        LIB_UNISTRING  = -lunistring
endif

ifdef UCS
UCSSUFFIX = -ucs
EXTRA_OBJ += matchw.o
endif

# ........................................................... curses ...

# possible values: ncurses, curses, pdcurses, pdcursesw or <empty>

ifdef UCS
        CURSES = ncursesw
else
        CURSES = ncurses
endif


# The default console for msys1 is the cmd.exe console.  rxvt and mintty are
# available for msys1, but I guess most people use cmd, console, or conemu for
# msys1.  Therefore we use pdcurses for msys1.  msys2's default console is
# mintty. For msys2 we use ncurses.
ifeq (msys,$(OS))
ifeq ($(MSYS_VERSION),1)
        CURSES = pdcurses
endif
endif

# The native Windows versions use PDCurses, because there are problems
# with the ncurses mingw port.
# All native Windows versions (with and without Unicode support) use wide
# (Unicode) curses functions.
ifeq (mingw,$(OS))
        CURSES = pdcursesw
endif

ifdef CURSES
ifdef UCS
EXTRA_OBJ += wcwidth.o
endif
endif

ifneq (,$(CURSES))
        DEFS_CURSES = -DWCD_USECURSES
        LIB_CURSES  = -l$(CURSES)
ifeq (os/2,$(OS))
        LIB_CURSES  += -ltinfo
endif
endif


INCPREFIX=/usr
ifeq ($(findstring MINGW,$(wcd_os)),MINGW)
ifeq ($(shell gcc -dumpmachine),i686-w64-mingw32)
INCPREFIX=/mingw32
CFLAGS_COMPILER = -DWCD_MINGW32_W64=1
else
ifeq ($(shell gcc -dumpmachine),x86_64-w64-mingw32)
INCPREFIX=/mingw64
else
INCPREFIX=/mingw
endif
endif
endif

# Each ncurses variant has its own include directory
# ncurses (normal)/ncursesw (wide char)/ncursest (threads)
ifeq ($(findstring ncurses,$(CURSES)),ncurses)
ifneq ($(wildcard $(INCPREFIX)/include/$(CURSES)/curses.h),)
        INCFLAGS = -I$(INCPREFIX)/include/$(CURSES) -I$(INCPREFIX)/include
endif
ifeq ($(NCURSES_DEBUG), 1)
        LIB_CURSES  = -l$(CURSES)_g
endif
else
        INCFLAGS = -I$(INCPREFIX)/include
endif

ifeq ($(CURSES),ncursesw)
        EXTRA_DEFS += -D_XOPEN_SOURCE -D_XOPEN_SOURCE_EXTENDED
endif

ifeq ($(CURSES),pdcursesw)
        EXTRA_DEFS += -DPDC_STATIC_BUILD -DPDC_WIDE
endif

# Local installation prefix of ncurses.
#LOCAL_NCURSES  = $(HOME)
#
#ifneq (, $(wildcard $(LOCAL_NCURSES)/include/ncurses.h))
#       NCFLAG = -I$(LOCAL_NCURSES)/include
#       NLFLAG = -L$(LOCAL_NCURSES)/lib
#endif

# ............................................................ flags ...

# Statically linking of a specific library can be done by linking
# to a lib*.a library file instead a lib*.s* library file.
# To link ncurses statically (if your system links by default
# dynamically) comment the LDFLAGS line and add the 'libncurses.a' file
# (often found as /usr/lib/libncurses.a) to the OBJS1 list.

CFLAGS_USER     =
ifeq ($(DEBUG), 1)
CFLAGS_OPT = -O0
else
CFLAGS_OPT = -O2
endif

CFLAGS  ?=
CFLAGS  += $(CFLAGS_OPT)
ifeq ($(DEBUG), 1)
        CFLAGS += -g
endif
CFLAGS  += -Wall -Wextra -Wno-unused-parameter -Wconversion $(RPM_OPT_FLAGS) $(CPPFLAGS) $(CFLAGS_USER)


EXTRA_CFLAGS    = -Ic3po \
                  $(CFLAGS_VERSION) \
                  $(CFLAGS_OS) \
                  $(CFLAGS_UCS) \
                  $(CFLAGS_COMPILER) \
                  $(WDEFS) \
                  $(NLSDEFS) \
                  $(NCFLAG) \
                  $(INCFLAGS) \
                  -DDEBUG=$(DEBUGMSG)

ifdef LFS
        EXTRA_CFLAGS += -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
endif

ifdef ASCII_TREE
        EXTRA_CFLAGS += -DASCII_TREE
endif

ifdef STATIC
        LDFLAG_STATIC = -static
endif

LDFLAGS_USER   =
LDFLAGS ?=
LDFLAGS += $(RPM_LD_FLAGS) \
           $(LDFLAGS_EXTRA) \
           $(NLFLAG) \
           $(LDFLAG_STATIC) \
           $(LDFLAGS_USER)

LIBS = $(LIB_CURSES) \
       $(LIB_UNISTRING) \
       $(LIBS_EXTRA)

DEFS_USER   =
DEFS            = $(DEF_UNIX) $(DEFS_CURSES) $(EXTRA_DEFS) $(DEFS_USER)

# .......................................................... targets ...

OBJS1 = \
        wcd.o \
        match.o \
        stack.o \
        nameset.o \
        intset.o \
        Error.o \
        Text.o \
        WcdStack.o \
        dirnode.o \
        display.o \
        wfixpath.o \
        wcddir.o \
        matchl.o \
        querycp.o \
        finddirs.o \
        $(EXTRA_OBJ)

ifneq (,$(CURSES))
OBJS1 += colors.o \
        graphics.o
endif

all: $(BIN) doc mofiles man

status:
	@echo "-- $(PACKAGE) Makefile settings begin --"
	@echo "OS            = $(OS)"
