=== debian/changelog ===
wcd (6.0.3-2) unstable; urgency=medium

  * QA upload.
  * Fix ftcbfs. (Closes: #929759)
  * Update Vcs to debian/wcd repo.
  * Add Rules-Requires-Root for lintian warning.
  * Use https with homepage.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 02 Jan 2020 23:55:04 +0000

wcd (6.0.3-1) unstable; urgency=medium

  * QA upload.
  * Update to upstream 6.0.3.
  * Update Standards-Version to 4.4.1.
  * Update compate level to 12.
  * Mark maintainer to QA.
  * Remove the patch, this version is not using build date.
  * Combine both NEWS file to a single NEWS.
  * Push to salsa and update Vcs.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 24 Dec 2019 23:08:07 +0000
