=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: wcd
 Section: utils
 Priority: optional
-Maintainer: Jari Aalto <jari.aalto@cante.net>
-Build-Depends: dpkg-dev (>= 1.16.2), debhelper (>= 10), libncursesw5-dev, libunistring-dev, ghostscript
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/wcd.git
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/wcd.git
-Homepage: http://waterlan.home.xs4all.nl
+Maintainer: Debian QA Group <packages@qa.debian.org>
+Build-Depends: dpkg-dev (>= 1.16.2), debhelper-compat (= 12), libncursesw5-dev, libunistring-dev, ghostscript
+Standards-Version: 4.4.1
+Rules-Requires-Root: no
+Vcs-Browser: https://salsa.debian.org/debian/wcd
+Vcs-Git: https://salsa.debian.org/debian/wcd.git
+Homepage: https://waterlan.home.xs4all.nl
 
 Package: wcd
 Architecture: any
