=== debian/watch ===
version=3
# http://sf.net/wcd/wcd-([.\d]*)\.tar\.gz
https://waterlan.home.xs4all.nl .*wcd-(\d\.[.\d]+)\.tar\.gz
